*
* X68k ZX.R version 1.20 Copyright 1994,95 M.Harashino
*


* Include File -------------------------------- *

		.include	common.mac

		.include	doscall.mac


* Fixed Number -------------------------------- *

el1:		.equ	10
el2:		.equ	6
el3:		.equ	6

margin:		.equ	2048
work_size:	.equ	1024
branch_max:	.equ	1024


* ZIP archive defile -------------------------- *

* METHOD
ZM_MKDIR:	.equ	-1			;zx.s Ŏgp
ZM_STORED:	.equ	0
ZM_SHRUNK:	.equ	1
ZM_REDUCED1:	.equ	2
ZM_REDUCED2:	.equ	3
ZM_REDUCED3:	.equ	4
ZM_REDUCED4:	.equ	5
ZM_IMPLODED:	.equ	6
ZM_TOKENIZED:	.equ	7
ZM_DEFLATED:	.equ	8
ZM_ENHDEFLATED:	.equ	9
ZM_DCLIMPLODED:	.equ	10
ZM_UNKNOWN:	.equ	11			;zx.s Ŏgp
ZM_TOTAL:	.equ	12			;V

* MUGIC NUMBER
CENTRAL_HDR_SIG:	.equ	'PK'<<16+$0102
LOCAL_HDR_SIG:		.equ	'PK'<<16+$0304
END_CENTRAL_SIG:	.equ	'PK'<<16+$0506

* LOCAL FILE HEADER
					.offset	0
					.ds.b	4	;'PK\x03\x04'
ZLFH_version_needed_to_extract:		.ds.b	2
ZLFH_general_purpose_bit_flag:		.ds	1
ZLFH_compression_method:		.ds	1
ZLFH_last_mod_file_time:		.ds	1
ZLFH_last_mod_file_date:		.ds	1
ZLFH_crc32:				.ds.l	1
ZLFH_csize:				.ds.l	1	;kTCY
ZLFH_ucsize:				.ds.l	1	;WJTCY
ZLFH_filename_length:			.ds	1
ZLFH_extra_field_length:		.ds	1
ZLFH_SIZE:
					.fail	$.ne.30

* CENTRAL DIRECTORY FILE HEADER
					.offset	0
					.ds.b	4	;'PK\x01\x02'
ZCDFH_version_made_by:			.ds.b	2
ZCDFH_version_needed_to_extract:	.ds.b	2
ZCDFH_general_purpose_bit_flag:		.ds	1
ZCDFH_compression_method:		.ds	1
ZCDFH_last_mod_file_time:		.ds	1
ZCDFH_last_mod_file_date:		.ds	1
ZCDFH_crc32:				.ds.l	1
ZCDFH_csize:				.ds.l	1
ZCDFH_ucsize:				.ds.l	1
ZCDFH_filename_length:			.ds	1
ZCDFH_extra_field_length:		.ds	1
ZCDFH_file_comment_length:		.ds	1
ZCDFH_disk_number_start:		.ds	1
ZCDFH_internal_file_attributes:		.ds	1
ZCDFH_external_file_attributes:		.ds.l	1
ZCDFH_relative_offset_local_header:	.ds.l	1
ZCDFH_SIZE:
					.fail	$.ne.46

* END CENTRAL DIRECTORY RECORD
					.offset	0
					.ds.b	4	;'PK\x05\x06'
ZECDR_number_this_disk:			.ds	1
ZECDR_num_disk_with_start_central_dir:	.ds	1
ZECDR_num_entries_centrl_dir_ths_disk:	.ds	1
ZECDR_total_entries_central_dir:	.ds	1
ZECDR_size_central_directory:		.ds.l	1
ZECDR_offset_start_central_directory:	.ds.l	1
ZECDR_zipfile_comment_length:		.ds	1
ZECDR_SIZE:
					.fail	$.ne.18+4


* Macro --------------------------------------- *

BIT_MOVEW:	.macro
.if MPU>=68020
		move	(a4)+,d5
		ror	#8,d5
.else
		movep	(1,a4),d5
		move.b	(a4),d5
		addq.l	#2,a4
.endif
		.endm

BIT:		.macro	num,reg
.if num.eq.1
		moveq	#(1<<1)-1,reg
		and	d5,reg
		lsr.l	#1,d5
		dbra	d6,@skip

		swap	d5
		BIT_MOVEW
		swap	d5
		moveq	#16-1,d6
@skip:
.elseif (2<=num).and.(num<=7)
		moveq	#(1<<num)-1,reg
		and	d5,reg
		lsr.l	#num,d5
		subq	#num,d6
		bcc	@skip

		not	d6
		lsl	d6,d5
		swap	d5
		BIT_MOVEW
		swap	d5
		lsr.l	d6,d5
		not	d6
		addi	#16,d6
@skip:
.else
		.dc	0/0
.endif
		.endm

BITREG:		.macro	num,reg
*		moveq	#0,reg
		bset	num,reg
		subq	#1,reg
		and	d5,reg
		lsr.l	num,d5
		sub.b	num,d6
		bcc	@skip

		not.b	d6
		lsl	d6,d5
		swap	d5
		BIT_MOVEW
		swap	d5
		lsr.l	d6,d5
		not.b	d6
		addi.b	#16,d6
@skip:
		.endm

BITPASS:	.macro	num
		lsr.l	num,d5
		sub.b	num,d6
		bcc	@skip

		not.b	d6
		lsl	d6,d5
		swap	d5
		BIT_MOVEW
		swap	d5
		lsr.l	d6,d5
		not.b	d6
		addi.b	#16,d6
@skip:
		.endm


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

start:
		bra.s	@f
		.dc.b	'#HUPAIR',0
@@:
		lea	(work,pc),a6
.if MPU>=68020
		bsr	mpu_check
		.cpu	MPU
.endif

	pea	(work+bss_bottom-start+$f0.w)
	pea	(16,a0)
	DOS	_SETBLOCK
	addq.l	#8,sp
	tst.l	d0
	bmi	memory_alloc_error

	move.l	#$ffffff,-(sp)
	DOS	_MALLOC
	and.l	D0,(sp)
	DOS	_MALLOC
	movea.l	(sp)+,a0
	tst.l	d0
	bmi	memory_alloc_error
	cmpa	#work_size,a0
	bcs	memory_alloc_error

	movea.l	D0,A5
	adda.l	D0,A0
	move.l	A0,temp_bottom-work(A6)

	moveq	#0,D7

	pea	1(A2)
	movea.l	A5,A2
	move.l	A2,-(SP)
	clr.l	-(SP)
	pea	zx_opt-work(A6)
	DOS	_GETENV
	addq.l	#12-4,sp
	move.l	d0,(sp)+
	bmi	@f
	bsr	get_command
@@:
	movea.l	(SP)+,A2
	bsr	get_command
	bsr	get_command9
	setquad	A5
	bsr	make_crc_table
	bsr	make_cnv_table

main:
	move.l	zip_file-work(A6),A0
	move.l	A0,D1

wild_card_check:
	move.b	(A0)+,D0
	beq	singular_archive
	cmpeq	#'?',D0,plural_archives
	cmpeq	#'*',D0,plural_archives
	bra	wild_card_check
wild_card_check9:

singular_archive:
	move.l	A5,temp_top-work(A6)
	move.l	D1,A0
	clr.w	-(SP)
	move.l	A0,-(SP)
	DOS	_OPEN
	addq.w	#6,SP
	move.l	D0,D6
	bpl	singular_archive1

	bsr	complete_ext
	clr.w	-(SP)
	move.l	A0,-(SP)
	DOS	_OPEN
	addq.w	#6,SP
	move.l	D0,D6
	bmi	file_open_error
singular_archive1:
	move.w	D6,-(SP)
	bsr	extract
	DOS	_CLOSE
	addq.w	#2,SP
	bra	done1
singular_archive9:

plural_archives:
	move.w	#-1,request_total-work(A6)
	move.l	D1,A0
	move.l	A5,A1
	lea	53+1(A5),A5
	move.l	A5,temp_top-work(A6)
		move	#$ff,-(SP)
	move.l	A0,-(SP)
	move.l	A1,-(SP)
	DOS	_FILES
	tst.l	D0
	bpl	plural_archives1

	bsr	complete_ext
	DOS	_FILES
	tst.l	D0
	bmi	file_open_error
plural_archives1:
		movea.l	(sp),a5
		moveq	#%0001_1000,d0		;DIR/VOL
		and.b	(21,a5),d0		;t@C̑
		bne	plural_archives5
		movea.l	(4,sp),a1
	lea	53+1(A5),A0
	movea.l	A0,A2
plural_archives2:
	move.l	A2,D1
plural_archives3:
	move.b	(A1)+,D0
	move.b	D0,(A2)+
	beq	plural_archives4
	cmpeq	#'/',D0,plural_archives2
	cmpeq	#':',D0,plural_archives2
	bra	plural_archives3
plural_archives4:
	lea	30(A5),A1
	move.l	D1,A2
@@:
	move.b	(A1)+,(A2)+
	bne	@b
	clr.w	-(SP)
	move.l	A0,-(SP)
	DOS	_OPEN
	addq.w	#6,SP
	move.l	D0,D6
	bmi	file_open_error
	move.w	D6,-(SP)
	bsr	extract
	DOS	_CLOSE
	addq.w	#2,SP
plural_archives5:
	DOS	_NFILES
	tst.l	D0
	bpl	plural_archives1
	lea	10(SP),SP
	bra	done1
plural_archives9:

done:
	move.w	#1,exit_code-work(A6)
done1:
	move.w	exit_code-work(A6),-(SP)
	DOS	_EXIT2

file_open_error:
	move.l	A0,-(SP)
	bsr	_eprint
	EPRINT_	file_open_error_message-work(A6)
	addq.w	#8,SP
	bra	done

****************************************************************

complete_ext:
	move.l	A0,-(SP)
@@:
	tst.b	(A0)+
	bne	@b
	subq.w	#1,A0
	lea	zip_ext-work(A6),A1
@@:
	move.b	(A1)+,(A0)+
	bne	@b
	movea.l	(SP)+,A0
	rts

****************************************************************

* 1.l ǂݍ(little-endian)
* in	a0.l	AhX
* out	d0.l	f[^
lpeek_intel:
		addq.l	#4,a0
		move.b	-(a0),-(sp)
		move	(sp)+,d0
		move.b	-(a0),d0
		swap	d0
		move.b	-(a0),-(sp)
		move	(sp)+,d0
		move.b	-(a0),d0
		rts

* 1.l ǂݍ(big-endian)
* in	a0.l	AhX
* out	d0.l	f[^
lpeek:
		move.b	(a0)+,-(sp)
		move	(sp)+,d0
		move.b	(a0)+,d0
		swap	d0
		move.b	(a0)+,-(sp)
		move	(sp)+,d0
		move.b	(a0)+,d0
		subq.l	#4,a0
		rts


extract:
	move.l	SP,stack2-work(A6)
	move.w	D7,status-work(A6)
	clr.l	src_total_size-work(A6)
	clr.l	ext_total_size-work(A6)
	clr.w	file_total-work(A6)

	tst.b	D7
	bmi	@f
	PRINT_	archive_message-work(A6)
	move.l	A0,(SP)
	bsr	_print
	PRINT_	item_list-work(A6)
	addq.w	#8,SP
@@:
		movea.l	(temp_bottom-work,a6),a4
		lea	(-2048,a4),a4		;pobt@
		cmpa.l	(temp_top-work,a6),a4
		bcs	memory_error

		move	#SEEK_END,-(sp)
		clr.l	-(sp)
		move	d6,-(sp)
		DOS	_SEEK
		addq.l	#8,sp
		move.l	d0,d3			;t@CTCY
		bmi	file_header_error
		subi.l	#ZECDR_SIZE-1,d3
		bls	file_header_error

		move.l	d3,d4
		subi.l	#66000,d4		;Oɂ͗L蓾Ȃ
		move.l	#1024,d2
* end central directory record 
zip_search_zecdr_loop:
		cmp.l	d2,d3
		bcc	@f
		move.l	d3,d2			;c 1024.b(+record)ȉ
@@:		sub.l	d2,d3

		clr	-(sp)			;SEEK_SET
		move.l	d3,-(sp)
		move	d6,-(sp)
		DOS	_SEEK
		addq.l	#8,sp
		tst.l	d0
		bmi	file_header_error

		pea	(ZECDR_SIZE-1)
		add.l	d2,(sp)
		pea	(a4)
		move	d6,-(sp)
		DOS	_READ
		addq.l	#10-4,sp
		cmp.l	(sp)+,d0
		bne	file_header_error

		lea	(-(ZECDR_SIZE-1),a4,d0.l),a0
		move.l	a0,d1
		sub.l	a4,d1			;oCg
		subq	#1,d1
@@:
		cmpi.b	#'P',-(a0)
		dbeq	d1,@b
		bne	@f
		bsr	lpeek
		cmpi.l	#END_CENTRAL_SIG,d0	;"PK\x05\x06"
		dbeq	d1,@b
		beq	zip_search_zecdr_found
@@:
		cmp.l	d4,d3
		blt	@f
		tst.l	d3
		bne	zip_search_zecdr_loop
@@:
		bra	file_header_error
zip_search_zecdr_found:
		add.l	a0,d3
		sub.l	a4,d3			;ECDR ̈ʒu

		lea	(ZECDR_size_central_directory,a0),a0
		bsr	lpeek_intel
		move.l	d0,d1			;CDFH ̃TCY
		beq	extract9		;̏
		move.l	d3,d2
		sub.l	d0,d2			;CDFH ̈ʒu

		addq.l	#4,a0			;ZECDR_offset_start_central_directory
		bsr	lpeek_intel
		sub.l	d2,d0
		bhi	file_header_error
		neg.l	d0			;preamble ̃TCY
		move.l	d0,(preamble_size-work,a6)

		clr	-(sp)			;SEEK_SET
		move.l	d2,-(sp)
		move	d6,-(sp)
		DOS	_SEEK			;central directory ܂ňړ
		addq.l	#8,sp
		tst.l	d0
		bmi	file_header_error

		movea.l	(temp_bottom-work,a6),a4
		suba.l	d1,a4
		subq.l	#4,a4
		cmpa.l	(temp_top-work,a6),a4
		bcs	memory_error

		move.l	d1,-(sp)
		pea	(a4)
		move	d6,-(sp)
		DOS	_READ			;central directory ǂݍ
		addq.l	#10-4,sp
		cmp.l	(sp)+,d0
		bne	file_read_error

		clr.b	(a4,d0.l)
		addq.l	#4,d3
		move.l	a4,(temp_bottom-work,a6)
		move.l	a4,(zip_cdfh_buf-work,a6)
		move.l	a4,(zip_cdfh_ptr-work,a6)
		move.l	d3,(zip_cdfh_size-work,a6)

	movea.l	temp_top-work(A6),A5
extract1:
	setquad	A5

	move.w	file_handle-work(A6),D1
	beq	@f
	bsr	file_delete
@@:

	move.l	#work_size,D0
	add.l	A5,D0
	cmp.l	temp_bottom-work(A6),D0
	bcs	extract1a
	bsr	file_write
	movea.l	temp_top-work(A6),A5
extract1a:
		movea.l	(zip_cdfh_ptr-work,a6),a4
		lea	(a4),a0
		bsr	lpeek
		cmpi.l	#CENTRAL_HDR_SIG,d0	;"PK\x01\x02"
		bne	extract9

		lea	(ZCDFH_general_purpose_bit_flag,a4),a0
		lea	(ZLFH_general_purpose_bit_flag,a5),a1
		move.b	(a0)+,(a1)+
		move.b	(a0)+,(a1)+

		bsr	lpeek_intel		;ZCDFH_compression_method
		cmpi	#ZM_UNKNOWN,d0
		bls	@f
		moveq	#ZM_UNKNOWN,d0
@@:		move	d0,(a1)+		;ZLFH_compression_method

		addq.l	#2,a0			;ZCDFH_last_mod_file_time
		moveq	#5-1,d1
@@:
		bsr	lpeek_intel
		addq.l	#4,a0
		move.l	d0,(a1)+
		dbra	d1,@b

		moveq	#1<<ATR_ARC,d0
		btst	#F_ATR,D7
		beq	@f
		move.b	(ZCDFH_external_file_attributes,a4),d0
		bne	@f			;DOS 
		moveq	#1<<ATR_ARC,d0
		btst	#6,(ZCDFH_external_file_attributes+2,a4)
		beq	@f
		moveq	#1<<ATR_EXEC+1<<ATR_ARC,d0
@@:		move.b	d0,($001a,a5)

		moveq	#0,d5
		move	(ZLFH_filename_length+2,a5),d5
		lea	(ZCDFH_SIZE,a4),a0	;t@C
		lea	(ZLFH_SIZE,a5),a1
		move	d5,d0
@@:
		move.b	(a0)+,(a1)+
		subq	#1,d0
		bne	@b
		clr.b	(a1)
		cmpi.b	#'/',-(a1)
		bne	@f			; / ȂfBNg
		move	#-1,(ZLFH_compression_method,a5)
@@:
		lea	(ZCDFH_relative_offset_local_header,a4),a0
		bsr	lpeek_intel
		add.l	(preamble_size-work,a6),d0
		moveq	#ZLFH_filename_length,d1
		add.l	d1,d0
		move.l	d0,(a5)			;f[^i[ʒu

		lea	(ZCDFH_extra_field_length,a4),a0
		bsr	lpeek_intel
		moveq	#0,d1
		move	d0,d1
		adda.l	d1,a4			;gtB[h΂
		swap	d0
		move	d0,d1			;ZCDFH_file_comment_length
		adda.l	d1,a4			;Rg΂

		lea	(ZCDFH_SIZE,a4,d5.l),a4	;̃wb_ʒu
		move.l	a4,(zip_cdfh_ptr-work,a6)

		lea	(ZLFH_SIZE,a5),a0
@@:
		move.b	(a0)+,d0
		beq	@f
		CMPNE	#SPC,d0,@b
		move.b	#'_',-(a0)
		bra	@b
@@:
		lea	(a0),a4			;display p̃obt@


		btst	#F_EXT,d7
		beq	extract2
		lea	(ZLFH_SIZE,a5),a1
		bsr	filename_compare
		bne	pass
extract2:
		move.l	(ZLFH_csize,a5),d0
		add.l	d0,(src_total_size-work,a6)
		move.l	(ZLFH_ucsize,a5),d0
		add.l	d0,(ext_total_size-work,a6)
*		tst	(ZLFH_compression_method,a5)
*		bmi	@f
		addq	#1,(file_total-work,a6)
*@@:
	movea.l	A4,A1
	bsr	display
	PRINT	crlf-work(A6)

	btst	#F_LIST,D7
	bne	list

.ifdef __EX__
		moveq	#$000000,d0
		cmpi	#ZM_DEFLATED,(ZLFH_compression_method,a5)
		bne	@f
		move	#$008000,d0		;deflate
@@:		move.l	d0,(dictionary_size-work,a6)
		clr	(division_flag-work,a6)
.endif
extract2a:
	move.l	#margin,D0
		add.l	(ZLFH_ucsize,a5),d0
	add.l	A4,D0
	cmp.l	temp_bottom-work(A6),D0
	bcs	extract3

	bsr	file_write

	movea.l	temp_top-work(A6),A0
	move.l	A0,D0
	cmpa.l	A0,A5
.ifdef __EX__
	bne	@f
	move.l	temp_bottom-work(A6),D0
	sub.l	A4,D0
	sub.l	dictionary_size-work(A6),D0
	asr.l	#1,D0
	andi.w	#$FC00,D0
	cmpi.l	#margin,D0
	blt	memory_error
	move.l	D0,division_size-work(A6)
	move.w	#$FFFF,division_flag-work(A6)
	bclr	#F_CACHE,D7
	bra	extract3
@@:
.else
	beq	memory_error
.endif
@@:
	move.l	(A5)+,(A0)+
	cmpa.l	A4,A5
	bcs	@b
	suba.l	A5,A0
	adda.l	A0,A4
	movea.l	D0,A5
	bra	extract2a
extract3:
		clr.l	(crc_work-work,a6)
		move.l	(ZLFH_crc32,a5),(crc-work,a6)
		tst	(ZLFH_compression_method,a5)
		bmi	make_directory

		move.l	(ZLFH_ucsize,a5),(percentage_work1-work,a6)
		clr.l	(percentage_work2-work,a6)
		clr	(percentage_flag-work,a6)

		btst	#0,(ZLFH_general_purpose_bit_flag,a5)
		bne	encrypted_error

		move	#1<<F_PRINT+1<<F_CACHE+1<<F_TEST,d0
		and	d7,d0
		bne	@f

	movea.l	A5,A0
	bsr	file_create
	tst.l	D0
	bmi	pass
	move.w	D0,file_handle-work(A6)
@@:
		clr	-(sp)			;f[^i[ʒuɈړ
		move.l	(a5),-(sp)
		move	d6,-(sp)
		DOS	_SEEK
		addq.l	#8,sp
		tst.l	d0
		bmi	file_read_error

		pea	(4)			;LFH ̃t@C/gtB[h
		pea	(a5)			;̒𒲂ׂ
		move	d6,-(sp)
		DOS	_READ
		addq.l	#10-4,sp
		sub.l	(sp)+,d0
		bne	file_read_error

		move	#SEEK_CUR,-(sp)		;t@C/gtB[h΂
		move	(a5),d0
		ror	#8,d0
		move.l	d0,-(sp)
		move	(2,a5),d0
		ror	#8,d0
		add.l	d0,(sp)
		move	d6,-(sp)
		DOS	_SEEK
		addq.l	#8,sp
		tst.l	d0
		bmi	file_read_error


		move	(ZLFH_compression_method,a5),d0
		beq	stored
		subq	#ZM_DEFLATED,d0
		bne	unknown_format_error


*deflated:
		SETQUAD	a4
		move.l	a4,(ZLFH_crc32,a5)
		move.l	(ZLFH_ucsize,a5),d4
		move.l	(ZLFH_csize,a5),d1
.ifdef __EX__
	tst.w	division_flag-work(A6)
	beq	@f
	move.l	division_size-work(A6),D0
	move.l	dictionary_size-work(A6),D4
	add.l	D0,D4
	cmp.l	D0,D1
	bcs	@f
	move.l	D0,D1
@@:
.endif
	add.l	A4,D4
	movea.l	A4,A3
	move.l	temp_bottom-work(A6),D0
	sub.l	D1,D0
	subq.l	#8,D0
	subq.l	#8,D0
	cmp.l	D4,D0
	bcs	@f
	move.l	D4,D0
@@:
	addq.l	#3,D0
	andi.w	#$FFFC,D0
	movea.l	D0,A4
	move.l	D1,-(SP)
	move.l	A4,-(SP)
	move.w	D6,-(SP)
	DOS	_READ
	addq.w	#6,SP
	cmp.l	(SP)+,D0
	bne	file_read_error
		sub.l	d0,(ZLFH_csize,a5)
.ifdef __EX__
	move.l	A4,src_top_address-work(A6)
	tst.w	division_flag-work(A6)
	beq	@f
	move.l	D4,ext_bottom_address2-work(A6)
	sub.l	dictionary_size-work(A6),D4
@@:
.endif
	move.l	D4,ext_bottom_address-work(A6)
	move.w	#$FFFF,stored_flag-work(A6)



	push	D6-D7/A5
	move.l	(A4)+,D5
	ror.w	#8,D5
	swap	D5
	ror.w	#8,D5
	moveq	#16-1,D6
	lea	table1(A6),A1
	lea	table2(A6),A2
extract4:
	BIT	3,D1
	moveq	#1,D0
	and.w	D1,D0
	move.w	D0,-(SP)
	lsr.w	#1,D1
	beq	extract_stored
	subq.w	#2,D1
	beq	extract_dynamic
	bcs	extract_fixed
	bra	system_error



extract_stored:
	clr.w	stored_flag-work(A6)
	move.w	D6,D0
	addq.w	#1,D0
	lsr.w	#3,D0
	addq.w	#2,D0
	suba.w	D0,A4
.if MPU>=68020
		move	(a4)+,d1
		ror	#8,d1
		move	(a4)+,d0
		ror	#8,d0
.else
		movep	(1,a4),d1
		move.b	(a4),d1
		addq.l	#2,a4
		movep	(1,a4),d0
		move.b	(a4),d0
		addq.l	#2,a4
.endif
	eor.w	D1,D0
	addq.w	#1,D0
	bne	system_error

.ifdef __EX__
	tst.w	division_flag-work(A6)
	beq	extract_stored2
	moveq	#0,D0
	move.w	D1,D0
	add.l	A3,D0
	sub.l	ext_bottom_address-work(A6),D0
	bcs	extract_stored2
	sub.w	D0,D1
	beq	extract_stored1
	subq.w	#1,D1
@@:
	move.b	(A4)+,(A3)+
	dbra	D1,@b
extract_stored1:
	move.w	D0,D1
	bsr	file_addition
extract_stored2:
.endif

	moveq	#15,D0
	and.w	D1,D0
	add.w	D0,D0
	neg.w	D0
	jmp	extract_stored3(PC,D0.w)
	.rept	15
	move.b	(A4)+,(A3)+
	.endm
extract_stored3:
	lsr.w	#4,D1
	beq	extract_stored4
	subq.w	#1,D1
@@:
	.rept	16
	move.b	(A4)+,(A3)+
	.endm
	dbra	D1,@b
extract_stored4:
.if MPU>=68020
		move.l	(a4)+,d5
		ror	#8,d5
		swap	d5
		ror	#8,d5
.else
		movep	(3,a4),d5
		move.b	(2,a4),d5
		swap	d5
		movep	(1,a4),d5
		move.b	(a4),d5
		addq.l	#4,a4
.endif
	moveq	#16-1,D6
	bra	extract8



extract_fixed:
	move.w	#$FFFF,-(SP)
	movea.l	A2,A0
	move.l	#$05050505,D0
	move.l	D0,(A0)+
	move.l	D0,(A0)+
	move.l	D0,(A0)+
	move.l	D0,(A0)+
	move.l	D0,(A0)+
	move.l	D0,(A0)+
	move.l	D0,(A0)+
	move.w	D0,(A0)+

	moveq	#$1E,D1
	moveq	#el2,D2
	movea.l	A2,A0
	lea	32(A0),A5
	moveq	#32,D7
	bsr	make_huffman_table

	movea.l	A1,A0
	move.l	#$07070707,D2
	move.l	#$08080808,D3
	move.l	#$09090909,D4
	moveq	#$90/4/4-1,D1
@@:
	move.l	D3,(A0)+
	move.l	D3,(A0)+
	move.l	D3,(A0)+
	move.l	D3,(A0)+
	dbra	D1,@b
	moveq	#$70/4/4-1,D1
@@:
	move.l	D4,(A0)+
	move.l	D4,(A0)+
	move.l	D4,(A0)+
	move.l	D4,(A0)+
	dbra	D1,@b
	move.l	D2,(A0)+
	move.l	D2,(A0)+
	move.l	D2,(A0)+
	move.l	D2,(A0)+
	move.l	D2,(A0)+
	move.l	D2,(A0)+
	move.l	D3,(A0)+
	move.l	D3,(A0)+

	move.w	#$120,D1
	moveq	#el1,D2
	movea.l	A1,A0
	lea	$0120(A0),A5
	cmp.w	D1,D7
	bcc	@f
	move.w	D1,D7
@@:
	bsr	make_huffman_table
	addq.w	#2,SP

	move.w	#$0100,D3
	move.w	#(1.shl.el1)-1,D4
	move.w	#$0120,D7
	lea	branch_table(A6),A5
	bra	extract5



extract_dynamic:
	clr.w	-(SP)
	BIT	5,D3
	addi.w	#$0101,D3
	cmpi.w	#$011F,D3
	bcc	system_error
	BIT	5,D4
	addq.w	#1,D4
	cmpi.w	#$001F,D4
	bcc	system_error

	lea	sort_table-work(A6),A0
	movea.l	A2,A5
	moveq	#0,D2
	.rept	8
	move.l	D2,(A5)+
	.endm
	BIT	4,D1
	addq.w	#4-1,D1
@@:
	BIT	3,D0
	move.b	(A0)+,D2
	move.b	D0,0(A2,D2.w)
	dbra	D1,@b

	moveq	#$13,D1
	moveq	#el3,D2
	movea.l	A2,A0
	moveq	#32,D7
	bsr	make_huffman_table

	movea.l	A1,A0
	moveq	#0,D2
	add.w	D3,D2
	add.w	D4,D2
	add.l	A0,D2
	moveq	#32,D7
	lea	branch_table(A6),A5
extract_dynamic1:
	moveq	#(1.shl.el3)-1,D0
	and.w	D5,D0
.if MPU>=68020
		move	(32,a2,d0.w*2),d0
.else
		add	d0,d0
		move	(32,a2,d0.w),d0
.endif
	cmp.w	D7,D0
	bcs	extract_dynamic1b
	moveq	#el3,D1
extract_dynamic1a:
	btst	D1,D5
	beq	@f
	addq.w	#2,D0
@@:
	addq.w	#1,D1
	move.w	0(A5,D0.w),D0
	cmp.w	D7,D0
	bcc	extract_dynamic1a
extract_dynamic1b:
	move.b	0(A2,D0.w),D1
	bitpass	D1

	cmpi.w	#$0010,D0
	bcc	@f
	move.b	D0,(A0)+
	cmpa.l	D2,A0
	bcs	extract_dynamic1
	bra	extract_dynamic4
@@:
	cmpi.w	#$0011,D0
	beq	extract_dynamic2
	bcs	extract_dynamic3
	moveq	#0,D0
	BIT	7,D1
	addi.w	#$000B-1,D1
@@:
	move.b	D0,(A0)+
	dbra	D1,@b
	cmpa.l	D2,A0
	bcs	extract_dynamic1
	bra	extract_dynamic4
extract_dynamic2:
	moveq	#0,D0
	BIT	3,D1
	addq.w	#3-1,D1
@@:
	move.b	D0,(A0)+
	dbra	D1,@b
	cmpa.l	D2,A0
	bcs	extract_dynamic1
	bra	extract_dynamic4
extract_dynamic3:
	move.b	-1(A0),D0
	BIT	2,D1
	addq.w	#3-1,D1
@@:
	move.b	D0,(A0)+
	dbra	D1,@b
	cmpa.l	D2,A0
	bcs	extract_dynamic1

extract_dynamic4:
	lea	0(A1,D3.w),A0
	movea.l	A2,A5
	move.w	D4,D1
	subq.w	#1,D1
@@:
	move.b	(A0)+,(A5)+
	dbra	D1,@b

	move.w	D4,D1
	moveq	#el2,D2
	movea.l	A2,A0
	lea	32(A0),A5
	moveq	#32,D7
	bsr	make_huffman_table

	move.w	#$0120,D4
	move.w	D3,D1
	moveq	#el1,D2
	movea.l	A1,A0
	lea	$0120(A0),A5
	cmp.w	D4,D7
	bcc	@f
	move.w	D4,D7
@@:
	bsr	make_huffman_table
	addq.w	#2,SP

	move.w	D4,D7
	move.w	#$0100,D3
	move.w	#(1.shl.el1)-1,D4
	lea	branch_table(A6),A5



extract5:
	move.w	D4,D0
	and.w	D5,D0
	add.w	D0,D0
	add.w	D7,D0
	move.w	0(A1,D0.w),D0
	cmp.w	D7,D0
	bcs	extract5b
	moveq	#el1,D1
extract5a:
	btst	D1,D5
	beq	@f
	addq.w	#2,D0
@@:
	addq.w	#1,D1
	move.w	0(A5,D0.w),D0
	cmp.w	D7,D0
	bcc	extract5a
extract5b:
	move.b	0(A1,D0.w),D1
	bitpass	D1

	sub.w	D3,D0
	bcc	extract6
	move.b	D0,(A3)+

.ifdef __EX__
	tst.w	division_flag-work(A6)
	beq	extract5
	cmpa.l	ext_bottom_address-work(A6),A3
	bne	extract5
	bsr	file_addition
	bra	extract5
.else
	move.w	D4,D0
	and.w	D5,D0
	add.w	D0,D0
	add.w	D7,D0
	move.w	0(A1,D0.w),D0
	cmp.w	D7,D0
	bcs	extract5d
	moveq	#el1,D1
extract5c:
	btst	D1,D5
	beq	@f
	addq.w	#2,D0
@@:
	addq.w	#1,D1
	move.w	0(A5,D0.w),D0
	cmp.w	D7,D0
	bcc	extract5c
extract5d:
	move.b	0(A1,D0.w),D1
	bitpass	D1

	sub.w	D3,D0
	bcc	extract6
	move.b	D0,(A3)+
	bra	extract5
.endif



extract6:
	beq	extract8
	lea	length_table-work(A6),A0
	add.w	D0,D0
	adda.w	D0,A0
	moveq	#0,D2
	move.w	32*2(A0),D1
	beq	@f
	bitreg	D1,D2
@@:
	add.w	(A0),D2

	moveq	#(1.shl.el2)-1,D0
	and.w	D5,D0
.if MPU>=68020
		move	(32,a2,d0.w*2),d0
.else
		add	d0,d0
		move	(32,a2,d0.w),d0
.endif
	cmpi.w	#32,D0
	bcs	extract6b
	moveq	#el2,D1
extract6a:
	btst	D1,D5
	beq	@f
	addq.w	#2,D0
@@:
	addq.w	#1,D1
	move.w	0(A5,D0.w),D0
	cmpi.w	#32,D0
	bcc	extract6a
extract6b:
	move.b	0(A2,D0.w),D1
	bitpass	D1

	lea	distance_table-work(A6),A0
	add.w	D0,D0
	adda.w	D0,A0
	moveq	#0,D0
	move.w	32*2(A0),D1
	beq	@f
	bitreg	D1,D0
@@:
	add.w	(A0),D0
	neg.w	D0
	lea	-1(A3,D0.w),A0

extract7:
.ifdef __EX__
	tst.w	division_flag-work(A6)
	beq	extract7_b
	moveq	#0,D0
	move.w	D2,D0
	add.l	A3,D0
	sub.l	ext_bottom_address-work(A6),D0
	bcs	extract7_b
	sub.w	D0,D2
	beq	extract7_a
	subq.w	#1,D2
@@:
	move.b	(A0)+,(A3)+
	dbra	D2,@b
extract7_a:
	move.w	D0,D2
	bsr	file_addition
extract7_b:
.endif

.ifdef __FAST__
	neg.w	D2
	addi.w	#258,D2
.if MPU>=68020
		jmp	(extract7a,pc,d2.w*2)
.else
		add	d2,d2
		jmp	(extract7a,pc,d2.w)
.endif
extract7a:
	.rept	258
	move.b	(A0)+,(A3)+
	.endm
	bra	extract5

.else

	moveq	#15,D0
	and.w	D2,D0
	add.w	D0,D0
	neg.w	D0
	jmp	extract7a(PC,D0.w)
	.rept	15
	move.b	(A0)+,(A3)+
	.endm
extract7a:
	lsr.w	#4,D2
	beq	extract5
	subq.w	#1,D2
@@:
	.rept	16
	move.b	(A0)+,(A3)+
	.endm
	dbra	D2,@b
	bra	extract5
.endif

extract8:
	movea.l	2+4*2(SP),A0
	bsr	percentage
	tst.w	(SP)+
	beq	extract4
	pop	D6-D7/A5
	cmpa.l	ext_bottom_address-work(A6),A3
	bne	system_error

	move.w	crc_check_level-work(A6),D0
	cmpeq	#2,D0,@f
	tst.w	stored_flag-work(A6)
	bne	@f
	moveq	#0,D0
@@:
extract8a:
	tst.w	D0
	bne	@f
		move.l	(ZLFH_ucsize,a5),d1
		movea.l	(ZLFH_crc32,a5),a0
	bsr	crc_check
	cmp.l	crc-work(A6),D2
	bne	crc_error
@@:
	move.l	link-work(A6),(A5)
	move.l	A5,link-work(A6)
	movea.l	A3,A5
	btst	#F_CACHE,D7
	bne	@f
	bsr	file_write
@@:
extract8b:
	move.w	status-work(A6),D0
	btst	#F_CACHE,D0
	beq	@f
	bset	#F_CACHE,D7
@@:
	subq.w	#1,request_total-work(A6)
	bne	extract1
	bra	extract9

make_directory:
	bsr	file_write
		move	#1<<F_PRINT+1<<F_NO_DIR+1<<F_TEST,d0
		and	d7,d0
		bne	make_directory1

		lea	(ZLFH_SIZE,a5),a1
	bsr	base
	move.l	A1,-(SP)
@@:
	tst.b	(A1)+
	bne	@b
	clr.b	-2(A1)
	DOS	_MKDIR
	movea.l	(SP)+,A1
	tst.l	D0
	bmi	make_directory1

change_date:
	move	#1<<ATR_ARC,-(SP)
	move.l	A1,-(SP)
	DOS	_CHMOD
	move.w	#2,4(SP)
	DOS	_OPEN
	move.l	D0,D1
	bmi	@f
	move.l	(ZLFH_last_mod_file_time,a5),-(sp)
	move.w	D1,-(SP)
	DOS	_FILEDATE
	DOS	_CLOSE
	addq.w	#6,SP
@@:
		moveq	#1<<ATR_SYS+1<<ATR_HID+1<<ATR_READ,d0
		and.b	($1a,a5),d0
		ori.b	#1<<ATR_DIR,d0
	move	d0,(4,sp)
	DOS	_CHMOD
	addq.w	#6,SP
change_date1:

make_directory1:
	movea.l	temp_top-work(A6),A5
	bra	extract8b

extract9:
	tst.b	D7
	bmi	@f
	PRINT	item_list2-work(A6)
		lea	(branch_table,a6),a5
		lea	(ZLFH_compression_method,a5),a0
		move	#ZM_TOTAL,(a0)+
	clr.l	-(sp)
	move.w	D6,-(SP)
	DOS	_FILEDATE
	addq.w	#6,SP
	move.l	D0,(A0)+
	addq.w	#4,A0
	move.l	src_total_size-work(A6),(A0)+
	move.l	ext_total_size-work(A6),(A0)+
		st	($001a,a5)
		lea	(ZLFH_SIZE,a5),a1
	moveq	#0,D0
	move.w	file_total-work(A6),D0
	moveq	#3,D1
	bsr	cnv_num
	addq.w	#1,A1
	bsr	display
	PRINT	item_list3-work(A6)
@@:
extractE:
	bsr	file_write

* CDFH obt@
		movea.l	(zip_cdfh_buf-work,a6),a4
		cmpa.l	(temp_bottom-work,a6),a4
		bne	@f			;L蓾Ȃ
		adda.l	(zip_cdfh_size-work,a6),a4
		move.l	a4,(temp_bottom-work,a6)
@@:
	move.w	status-work(A6),D7
	movea.l	stack2-work(A6),SP
	rts

* i[f[^̓ǂݍݒOɃV[NĂׁA
* ڂĂt@C̃f[^΂Kv͂Ȃ.
list:
pass:
		bra	extract1


stored:
		movea.l	a4,a3
		move.l	a3,(ZLFH_crc32,a5)
.ifdef __EX__
	move.l	division_size-work(A6),D1
	add.l	D1,D1
	move.l	D1,division_size-work(A6)
stored1:
	tst.w	division_flag-work(A6)
	beq	stored2
	move.l	D1,-(SP)
	move.l	A3,-(SP)
	move.w	D6,-(SP)
	DOS	_READ
	addq.w	#6,SP
	cmp.l	(SP)+,D0
	bne	file_read_error
	push	D6-D7/A5
	subq.w	#2,SP
	bsr	file_addition
	addq.w	#2,SP
	pop	D6-D7/A5
	movea.l	A5,A0
	bsr	percentage
	bra	stored1
stored2:
.endif
		move.l	(ZLFH_csize,a5),-(sp)
	move.l	A3,-(SP)
	move.w	D6,-(SP)
	DOS	_READ
	addq.w	#6,SP
	cmp.l	(SP)+,D0
	bne	file_read_error
	adda.l	D0,A3
	move.w	crc_check_level-work(A6),D0
	beq	@f
	subq.w	#1,D0
@@:
	bra	extract8a



memory_alloc_error:
	EPRINT	memory_alloc_error_message-work(A6)
	bra	done

memory_error:
	pea	memory_error_message-work(A6)
	bra	@f

encrypted_error:
	pea	encrypted_error_message-work(A6)
	bra	@f

unknown_format_error:
	pea	unknown_format_error_message-work(A6)
@@:
	bsr	_eprint
	addq.w	#4,SP
	bra	pass

file_header_error:
		pea	(file_header_error_message-work,a6)
		bra	@f

file_read_error:
	pea	file_read_error_message-work(A6)
	bra	@f

branch_error:
	pea	branch_error_message-work(A6)
	bra	@f

system_error:
	pea	system_error_message-work(A6)
	bra	@f

format_error:
	pea	format_error_message-work(A6)
	bra	@f

crc_error:
	pea	crc_error_message-work(A6)
@@:
	move.w	status-work(A6),D7
	bsr	_eprint
	addq.w	#4,SP
	move.w	#1,exit_code-work(A6)
	bra	extractE

****************************************************************

* nt}؂e[uWJ
* in	D1-D2/D7/A0/A5
* out	
* break	D0-D2

* D1 = 
* D2 = WJrbg
* D7 = u`JE^
* A0 = rbge[u
* A5 = WJe[u

make_huffman_table:
	push	D3-D6/A1-A4
	lea	-(16*2)*2(SP),SP
	moveq	#0,D0
	.rept	8
	move.l	D0,-(SP)
	.endm
	move.w	D0,-(SP)

	movea.l	A0,A2
	move.w	D1,D3
	subq.w	#1,D3
@@:
	move.b	(A2)+,D0
	add.b	D0,D0
	addq.w	#1,0(SP,D0.w)
	dbra	D3,@b

	lea	2(SP),A2
	moveq	#2,D6
	moveq	#1,D5
	moveq	#0,D4
	moveq	#16-1,D3
@@:
	move.w	D4,D0
	lsl.w	D3,D0
	add.w	(A2),D4
	add.w	D4,D4
	ror.w	#1,D5
	add.w	D6,D6
	move.w	D6,32*2(A2)
	move.w	D5,16*2(A2)
	move.w	D0,(A2)+
	dbra	D3,@b
	tst.w	(16*3+1)*2+(8+1)*4(SP)
	bne	@f
	tst.w	D4
	bne	system_error
@@:

	moveq	#0,D6
	bset	D2,D6
	subq.w	#1,D6

	moveq	#0,D0
	bset	D2,D0
.if MPU>=68020
		lea	(a5,d0.w*2),a2
.else
		add	d0,d0
		lea	(a5,d0.w),a2
.endif
	moveq	#0,D0
	moveq	#0,D4
	moveq	#0,D5
	movea.l	D0,A1
	movea.l	D0,A3
	movea.l	D0,A4
	move.w	D6,D3
	lsr.w	#6,D3
@@:
	movem.l	D0/D4-D5/A1/A3-A4,-(A2)
	movem.l	D0/D4-D5/A1/A3-A4,-(A2)
	movem.l	D0/D4-D5/A1/A3-A4,-(A2)
	movem.l	D0/D4-D5/A1/A3-A4,-(A2)
	movem.l	D0/D4-D5/A1/A3-A4,-(A2)
	movem.l	D0/D4,-(A2)
	dbra	D3,@b

make_huffman_table1:
	moveq	#0,D3
	lea	branch_table(A6),A1
	movea.l	cnv_table-work(A6),A3
make_huffman_table2:
	moveq	#0,D5
	move.b	0(A0,D3.w),D5
	beq	make_huffman_table9

	lea	0(SP,D5.w),A4
	adda.w	D5,A4
	move.w	(A4),D4
	move.w	16*2(A4),D0
	add.w	D0,(A4)

	moveq	#0,D0
	move.b	D4,D0
	lsr.w	#8,D4
.if MPU>=68020
		move	(a3,d0.w),d0
.else
		lea	(a3,d0.w),a2
		movep	(0,a2),d0
.endif
		move.b	(a3,d4.w),d0
	sub.w	D2,D5
	bls	make_huffman_table4

	move.w	D0,D4
	and.w	D6,D0
.if MPU>=68020
		lea	(a5,d0.w*2),a4
.else
		add	d0,d0
		lea	(a5,d0.w),a4
.endif
	lsr.w	D2,D4
	subq.w	#1,D5
make_huffman_table3:
	move.w	(A4),D0
	bne	@f
	move.w	D7,D0
	addq.w	#4,D7
	move.w	D0,(A4)
	clr.l	0(A1,D0.w)
@@:
	lea	0(A1,D0.w),A4
	lsr.w	#1,D4
	bcc	@f
	addq.w	#2,A4
@@:
	dbra	D5,make_huffman_table3
	move.w	D3,(A4)
	bra	make_huffman_table9

make_huffman_table4:
	move.w	32*2(A4),D4
.if MPU>=68020
		lea	(a5,d0.w*2),a4
.else
		add	d0,d0
		lea	(a5,d0.w),a4
.endif
	moveq	#0,D0
	neg.w	D5
	bset	D5,D0
	subq.w	#4,D5
	bls	make_huffman_table5
	lsr.w	#4,D0
	subq.w	#1,D0
@@:
	.rept	16
	move.w	D3,(A4)
	adda.w	D4,A4
	.endm
	dbra	D0,@b
	bra	make_huffman_table9

make_huffman_table5:
	add.w	D0,D0
	add.w	D0,D0
	lea	make_huffman_table6+2-work(A6),A2
	suba.w	D0,A2
	jmp	(A2)
	.rept	15
	move.w	D3,(A4)
	adda.w	D4,A4
	.endm
	move.w	D3,(A4)
make_huffman_table6:

make_huffman_table9:
	addq.w	#1,D3
	cmp.w	D1,D3
	bcs	make_huffman_table2
	cmpi.w	#branch_max*4,D7
	bcc	branch_error
	lea	(16*3+1)*2(SP),SP
	pop	D3-D6/A1-A4
	rts

****************************************************************

* rbg񔽓]pe[u쐬
* in	A5
* out	
* break	D0-D4

make_cnv_table:
	move.l	A5,cnv_table-work(A6)
	move.b	#$80,D3
	move.b	#$C0,D4
	moveq	#0,D0
	moveq	#256/4-1,D1
make_cnv_table1:
	move.b	D0,(A5)+
	eor.b	D3,D0
	move.b	D0,(A5)+
	eor.b	D4,D0
	move.b	D0,(A5)+
	eor.b	D3,D0
	move.b	D0,(A5)+
	eor.b	D4,D0
	bchg	#5,D0
	beq	@f
	bchg	#4,D0
	beq	@f
	bchg	#3,D0
	beq	@f
	bchg	#2,D0
	beq	@f
	bchg	#1,D0
	beq	@f
	bchg	#0,D0
@@:
	dbra	D1,make_cnv_table1
	rts

****************************************************************

* bqbe[u쐬
* in	A5
* out	
* break	D0-D4

make_crc_table:
	cmpi.w	#2,crc_check_level-work(A6)
	bcc	make_crc_table9

	move.l	A5,crc_table-work(A6)
	move.l	#$EDB88320,D3
	move.l	#$77073096,D4
	moveq	#0,D0
	moveq	#128-1,D1
make_crc_table1:
	move.l	D0,D2
	.rept	7
	lsr.l	#1,D2
	bcc	@f
	eor.l	D3,D2
@@:
	.endm
	move.l	D2,(A5)+
	eor.l	D4,D2
	move.l	D2,(A5)+
	addq.w	#1,D0
	dbra	D1,make_crc_table1
make_crc_table9:
	rts

****************************************************************

* bqb`FbN
* in	A5
* out	
* break	D0-D3/A0-A1

crc_check:
	move.l	crc_work-work(A6),D2
	not.l	D2
	movea.l	crc_table-work(A6),A1
	moveq	#15,D3
	and.w	D1,D3
	subq.w	#1,D3
	bcs	crc_check2
crc_check1:
	moveq	#0,D0
	move.b	(A0)+,D0
	eor.b	D2,D0
.if MPU>=68020
		move.l	(a1,d0.w*4),d0
.else
		add	d0,d0
		add	d0,d0
		move.l	(a1,d0.w),d0
.endif
	lsr.l	#8,D2
	eor.l	D0,D2
	dbra	D3,crc_check1
crc_check2:
	lsr.l	#4,D1
	subq.l	#1,D1
	bcs	crc_check4
.if MPU>=68020
		moveq	#0,d0
.endif
crc_check3:
	.rept	16
.if MPU>=68020
		move.b	(a0)+,d0
		eor.b	d2,d0
		move.l	(a1,d0.w*4),d3
		lsr.l	#8,d2
		eor.l	d3,d2
.else
		moveq	#0,d0
		move.b	(a0)+,d0
		eor.b	d2,d0
		add	d0,d0
		add	d0,d0
		move.l	(a1,d0.w),d0
		lsr.l	#8,d2
		eor.l	d0,d2
.endif
	.endm
	dbra	D1,crc_check3
	addq.w	#1,D1
	subq.l	#1,D1
	bcc	crc_check3
crc_check4:
	not.l	D2
	move.l	D2,crc_work-work(A6)
	rts

****************************************************************

* t@C̈ꊇo
* in	
* out	
* break	D0-D2/A0-A1

file_write:
	lea	link-work(A6),A0
	move.l	(A0),D0
	beq	file_write9
@@:
	movea.l	A0,A1
	movea.l	D0,A0
	move.l	(A0),D0
	bne	@b
	move.l	D0,(A1)
	btst	#F_TEST,D7
	bne	file_write

	btst	#F_PRINT,D7
	beq	@f
	moveq	#STDOUT,D1
	bra	file_write8
@@:
	move.w	file_handle-work(A6),D1
	bne	file_write8
	bsr	file_create
	move.l	D0,D1
	bmi	file_write
file_write8:
	clr.w	file_handle-work(A6)
		move.l	(ZLFH_ucsize,a0),d0
		beq	@f
		move.l	d0,-(sp)
		move.l	(ZLFH_crc32,a0),-(sp)
		move	d1,-(sp)
		DOS	_WRITE
		addq.l	#6,sp
		cmp.l	(sp)+,d0
		bne	file_write_error
@@:
	btst	#F_PRINT,D7
	bne	file_write
		move.l	(ZLFH_last_mod_file_time,a0),-(sp)
	move.w	D1,-(SP)
	DOS	_FILEDATE
	DOS	_CLOSE
	addq.w	#6,SP
	bra	file_write
file_write9:
	rts

file_write_error:
		btst	#F_PRINT,d7
		beq	file_write_error2
		EPRINT	(stdout_message-work,a6)
		bra	@f
file_write_error2:
		bsr	file_delete
		EPRINT	(filename_work,a6)
@@:
		EPRINT	(file_write_error_message-work,a6)
		bra	file_write

.ifdef __EX__
file_addition:
	push	D1-D7/A0-A2
	movem.l	4*10+4+2(SP),D6-D7/A0
	move.l	ext_bottom_address-work(A6),D0
	move.l	ext_bottom_address2-work(A6),D1
	move.l	division_size-work(A6),D2
	cmp.l	D1,D0
	beq	file_addition1
	add.l	D2,D0
	cmp.l	D1,D0
	bcs	@f
	move.l	D1,D0
@@:
	move.l	D0,ext_bottom_address-work(A6)
	bra	file_addition3
file_addition1:
	move.w	file_handle-work(A6),D1
	btst	#F_PRINT,D7
	beq	@f
	moveq	#STDOUT,D1
@@:
		move.l	(ZLFH_crc32,a0),a3
	move.l	D2,-(SP)
	move.l	A3,-(SP)
	move.w	D1,-(SP)
	DOS	_WRITE
	addq.w	#6,SP
	cmp.l	(SP)+,D0
	bne	file_write_error

	move.w	crc_check_level-work(A6),D0
	subq.w	#2,D0
	beq	@f
	push	D2/A0
	move.l	D2,D1
	movea.l	A3,A0
	bsr	crc_check
	pop	D2/A0
@@:

	add.l	D2,percentage_work2-work(A6)
		sub.l	D2,(ZLFH_ucsize,a0)
		move.l	(ZLFH_ucsize,a0),d0
	sub.l	dictionary_size-work(A6),D0
	sub.l	D2,D0
	bhi	@f
	add.l	D0,ext_bottom_address-work(A6)
	clr.w	division_flag-work(A6)
@@:
	lea	0(A3,D2.l),A1
	move.l	dictionary_size-work(A6),D1
	beq	file_addition9
	lsr.l	#4,D1
	subq.w	#1,D1
@@:
	move.l	(A1)+,(A3)+
	move.l	(A1)+,(A3)+
	move.l	(A1)+,(A3)+
	move.l	(A1)+,(A3)+
	dbra	D1,@b

file_addition3:
	movea.l	src_top_address-work(A6),A1
	movea.l	A1,A2
	move.l	A4,D0
	sub.l	A1,D0
	move.l	D2,D1
	sub.l	D0,D1
	bls	system_error
	subq.l	#1,D1
@@:
	move.b	(A4)+,(A2)+
	dbra	D1,@b
	addq.w	#1,D1
	subq.l	#1,D1
	bcc	@b
	movea.l	A1,A4
		move.l	(ZLFH_csize,a0),d1
	beq	file_addition9
	cmp.l	D1,D0
	bcs	@f
	move.l	D1,D0
@@:
	move.l	D0,-(SP)
	move.l	A2,-(SP)
	move.w	D6,-(SP)
	DOS	_READ
	lea	10(SP),SP
		sub.l	d0,(ZLFH_csize,a0)

file_addition9:
	pop	D1-D7/A0-A2
	rts
.endif

****************************************************************

* t@C̐VK쐬
* in	A0
* out	
* break	D0-D2/A1

file_create:
		move.l	d3,-(sp)
		moveq	#0,d2
		move.b	($001a,a0),d2
		move.l	(ZLFH_last_mod_file_time,a0),d3
		lea	(ZLFH_SIZE,a0),a1
		bsr	file_create_sub
		move.l	(sp)+,d3
		rts

****************************************************************

* t@C\
* in	A1/A5
* out	
* break	D0-D2/A0-A1

display:
	tst.w	message_level-work(A6)
	beq	display9
	tst.b	D7
	bmi	display8
	move.l	A1,-(SP)

		lea	(method_table-work,a6),a0
		move	(ZLFH_compression_method,a5),d0
		bpl	@f
		moveq	#ZM_STORED,d0		;directory
@@:		lsl	#3,d0
		adda	d0,a0
		moveq	#8-1,d0
@@:		move.b	(a0)+,(a1)+
		dbra	d0,@b

		lea	(cnv_num-work,a6),a0

		move.l	(ZLFH_csize,a5),d0
	moveq	#8,D1
	jsr	(A0)
	move.b	#SPC,(A1)+

		move.l	(ZLFH_ucsize,a5),d0
	moveq	#8,D1
	jsr	(A0)
	move.b	#SPC,(A1)+

		move.l	(ZLFH_csize,a5),d0
		move.l	(ZLFH_ucsize,a5),d1
		beq	display1
@@:
	cmpi.l	#$00010000,D1
	bcs	@f
	lsr.l	D0
	lsr.l	D1
	bra	@b
@@:
	mulu	#1000*2,D0
	divu	D1,D0
	addq.w	#1,D0
	lsr.w	#1,D0
	ext.l	D0
display1:
	moveq	#4,D1
*	move.b	#'(',(A1)+
	jsr	(A0)
	move.b	-(A1),D0
	cmpi.b	#SPC,-(A1)
	bne	@f
	move.b	#'0',(A1)
@@:
	addq.w	#1,A1
	move.b	#'.',(A1)+
	move.b	D0,(A1)+
	move.b	#'%',(A1)+
*	move.b	#')',(A1)+
	moveq	#SPC,d0
	move.b	d0,(a1)+
	move.b	d0,(a1)+

		move.b	($001a,a5),d2
		cmpne	#$ff,d2,display2
		moveq	#8-1,d0
@@:
		move.b	#SPC,(a1)+
		dbra	d0,@b
		bra	display3
display2:
		moveq	#'d',d0
		btst	#ATR_DIR,d2
		bne	@f
		moveq	#'l',d0
		btst	#ATR_LINK,d2
		bne	@f
		moveq	#'v',d0
		btst	#ATR_VOL,d2
		bne	@f
		moveq	#'-',d0
@@:		move.b	d0,(a1)+

		moveq	#'-',d0
		btst	#ATR_ARC,d2
		beq	@f
		moveq	#'a',d0
@@:		move.b	d0,(a1)+

		moveq	#'-',d0
		btst	#ATR_SYS,d2
		beq	@f
		moveq	#'s',d0
@@:		move.b	d0,(a1)+

		moveq	#'-',d0
		btst	#ATR_HID,d2
		beq	@f
		moveq	#'h',d0
@@:		move.b	d0,(a1)+

		move.b	#'r',(A1)+

		moveq	#'-',d0
		btst	#ATR_READ,d2
		bne	@f
		moveq	#'w',d0
@@:		move.b	d0,(a1)+

		moveq	#'-',d0
		tst.b	d2
		bpl	@f
		moveq	#'x',d0
@@:		move.b	d0,(a1)+

		move.b	#SPC,(a1)+

display3:
		move.l	(ZLFH_last_mod_file_time,a5),d2
	swap	D2
	rol.w	#7,D2
	moveq	#$7F,D0
	and.w	D2,D0
	addi.w	#80,D0
	moveq	#2,D1
	jsr	(A0)
	move.b	#'-',(A1)+
	rol.w	#4,D2
	moveq	#$0F,D0
	and.w	D2,D0
	addi.w	#100,D0
	moveq	#2,D1
	jsr	(A0)
	move.b	#'-',(A1)+
	rol.w	#5,D2
	moveq	#$1F,D0
	and.w	D2,D0
	addi.w	#100,D0
	moveq	#2,D1
	jsr	(A0)
	move.b	#SPC,(A1)+

	swap	D2
	rol.w	#5,D2
	moveq	#$1F,D0
	and.w	D2,D0
	addi.w	#100,D0
	moveq	#2,D1
	jsr	(A0)
	move.b	#':',(A1)+
	rol.w	#6,D2
	moveq	#$3F,D0
	and.w	D2,D0
	addi.w	#100,D0
	moveq	#2,D1
	jsr	(A0)
	move.b	#':',(A1)+
	rol.w	#5,D2
	moveq	#$1F,D0
	and.w	D2,D0
	add.w	D0,D0
	addi.w	#100,D0
	moveq	#2,D1
	jsr	(A0)
	move.b	#SPC,(A1)+
	clr.b	(A1)+

	DOS	_PRINT
	addq.l	#4,SP
display8:
		DPRINT	(ZLFH_SIZE,a5)
display9:
		rts

****************************************************************

* Ɛis󋵕\
* in	A0/A3
* out	
* break	D0-D2/A1

percentage:
	tst.w	message_level-work(A6)
	beq	percentage9
	move.l	A3,D0
		sub.l	(ZLFH_crc32,a0),d0
	add.l	percentage_work2-work(A6),D0
	move.l	percentage_work1-work(A6),D1
		beq	percentage9		;Length=0 ΍
	tst.w	percentage_flag-work(A6)
	bne	@f
	cmp.l	D1,D0
	beq	percentage9
@@:
	moveq	#1,D2
	swap	D2
@@:
	cmp.l	D2,D1
	bcs	@f
	lsr.l	#2,D0
	lsr.l	#2,D1
	bra	@b
@@:
	mulu	#100,D0
	divu	D1,D0
	ext.l	D0
	moveq	#3,D1
	move.l	A1,D2
	lea	-10(SP),SP
	movea.l	SP,A1
	move.l	A1,-(SP)
	bsr	cnv_num
	move.b	#'%',(A1)+
	move.l	#BS<<24+BS<<16+BS<<8+BS,(A1)+
	clr.b	(A1)+
	bsr	_eprint
	lea	4+10(SP),SP
	movea.l	D2,A1
	move.w	#$FFFF,percentage_flag-work(A6)
percentage9:
	rts

****************************************************************

* R}hC
* in	A2/A5
* out	D7
* break	D0/A0

get_command:

hupair:
	lea	1024(A5),A0
	st	(A0)+
	move.l	A0,-(SP)
hupair1:
	move.b	(A2)+,D0
	beq	hupair5
	cmpeq	#SPC,D0,hupair1
	subq.w	#1,A2
hupair2:
	move.b	(A2)+,D0
	cmpeq	#"'",D0,hupair4
	cmpeq	#'"',D0,hupair4
	cmpeq	#SPC,D0,hupair3
	cmpne	#'\',D0,@f
	moveq	#'/',D0
@@:
	move.b	D0,(A0)+
	beq	hupair5
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	hupair2
	move.b	(A2)+,(A0)+
	bra	hupair2
hupair3:
	tst.b	-1(A0)
	beq	hupair1
	clr.b	(A0)+
	bra	hupair1
hupair4:
	move.b	(A2)+,D1
	cmpeq	D0,D1,hupair2
	cmpne	#'\',D1,@f
	moveq	#'/',D1
@@:
	move.b	D1,(A0)+
	beq	hupair5
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	hupair4
	move.b	(A2)+,(A0)+
	bra	hupair4
hupair5:
	clr.b	(A0)
	move.l	(SP)+,A2
hupair9:

get_command1:
	move.b	(A2)+,D0
	beq	get_command8
	cmpeq	#'-',D0,switch
	subq.w	#1,A2
	bset	#F_ARC,D7
	bne	get_command2
	move.l	A5,zip_file-work(A6)
@@:
	move.b	(A2)+,(A5)+
	bne	@b
	addq.w	#4,A5
	bra	get_command1

get_command2:
	bset	#F_EXT,D7
	bne	@f
	move.l	A5,ext_file-work(A6)
@@:
	move.b	(A2)+,(A5)+
	bne	@b
	lea	-4(A5),A0
	moveq	#'*',D0
	cmpne	(A0)+,D0,get_command1
	cmpne	#'.',(A0)+,get_command1
	cmpne	(A0)+,D0,get_command1
	subq.w	#3,A5
	clr.b	(A5)+
	bra	get_command1

switch0:
	bset	D0,D7
switch:
	move.b	(A2)+,D0
	beq	get_command1
	cmpeq	#'?',D0,help
	cmpeq	#'1',D0,s_list
	ori.b	#$20,D0
	cmpeq	#'h',D0,help
	cmpeq	#'l',D0,s_list1
	cmpeq	#'v',D0,s_list1
	cmpeq	#'e',D0,s_extract
	cmpeq	#'x',D0,s_extract1
	cmpeq	#'a',D0,s_attribute
	cmpeq	#'b',D0,s_base
	cmpeq	#'c',D0,s_not_compare_time
	cmpeq	#'m',D0,s_not_inquire
	cmpeq	#'n',D0,s_no_message
	cmpeq	#'i',D0,s_byte_code_check
	cmpeq	#'t',D0,s_archive_test
	cmpeq	#'w',D0,s_write_cache
	cmpeq	#'p',D0,s_output_console
	cmpeq	#'s',D0,s_disk_free_check

switch_error:
	pea	switch_error_message-work(A6)
	bra	@f

command_error:
	pea	command_error_message-work(A6)
	bra	@f

help:
	pea	help_message-work(A6)
@@:
	bsr	_eprint
	addq.w	#4,SP
	bra	done

s_list:
	bset	#F_LIST_1,D7
s_list1:
	moveq	#F_LIST,D0
	bra	switch0

s_extract:
	bset	#F_NO_DIR,D7
s_extract1:
	bsr	get_num
	move.w	D0,crc_check_level-work(A6)
	subq.w	#2,D0
	bhi	command_error
	bra	switch

s_attribute:
	moveq	#F_ATR,D0
	bra	switch0

s_base:
	bset	#F_BASE,D7
	tst.b	(A2)
	bne	@f
	addq.w	#1,A2
@@:
	tst.b	(A2)
	beq	command_error
	move.l	A2,base_directory-work(A6)
@@:
	tst.b	(A2)+
	bne	@b
	bra	get_command1

s_output_console:
	bset	#F_PRINT,D7

s_no_message:
	bsr	get_num
	move.w	D0,message_level-work(A6)
	subq.w	#2,D0
	bhi	command_error
	addq.w	#2,D0
	bne	switch

s_not_inquire:
	moveq	#F_NO_INQ,D0
	bra	switch0

s_byte_code_check:
	moveq	#F_CASE,D0
	bra	switch0

s_not_compare_time:
	bsr	get_num
	move.w	D0,compare_level-work(A6)
	subq.w	#2,D0
	bhi	command_error
	bra	switch

s_archive_test:
	bset	#F_TEST,D7
	bra	s_extract1

s_disk_free_check:
	clr.w	disk_free_check_flag-work(A6)
	bclr	#F_CACHE,d7
	bra	switch

s_write_cache:
	move.w	#-1,disk_free_check_flag-work(A6)
	moveq	#F_CACHE,D0
	bra	switch0

get_command8:
	rts

get_command9:
	tst.w	D7
	bpl	help

	clr.b	(A5)+
	btst	#F_BASE,D7
	beq	get_command9a

	movea.l	base_directory-work(A6),A2
	move.l	A5,base_directory-work(A6)
@@:
	move.b	(A2)+,(A5)+
	bne	@b
	subq.w	#2,A5
	cmpeq	#':',(A5)+,@f
	moveq	#'/',D0
	cmpeq	-1(A5),D0,@f
	move.b	D0,(A5)+
@@:
	clr.b	(A5)+

get_command9a:
	btst	#F_EXT,D7
	beq	get_command9e
	movea.l	ext_file-work(A6),A2
	moveq	#0,D1
get_command9b:
	tst.b	(A2)
	beq	get_command9d
@@:
	move.b	(A2)+,D0
	beq	@f
	cmpeq	#'?',D0,get_command9c
	cmpeq	#'*',D0,get_command9c
	bra	@b
@@:
	addq.w	#1,D1
	bne	get_command9b
get_command9c:
	moveq	#-1,D1
get_command9d:
	move.w	D1,request_total-work(A6)
get_command9e:
	rts


* Data Section -------------------------------- *

		.data
		.even

length_table:
		.dc	$0000,$0003,$0004,$0005,$0006,$0007,$0008,$0009
		.dc	$000a,$000b,$000d,$000f,$0011,$0013,$0017,$001b
		.dc	$001f,$0023,$002b,$0033,$003b,$0043,$0053,$0063
		.dc	$0073,$0083,$00a3,$00c3,$00e3,$0102,$0000,$0000

		.dc	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
		.dc	$0000,$0001,$0001,$0001,$0001,$0002,$0002,$0002
		.dc	$0002,$0003,$0003,$0003,$0003,$0004,$0004,$0004
		.dc	$0004,$0005,$0005,$0005,$0005,$0000,$0000,$0000

distance_table:
		.dc	$0000,$0001,$0002,$0003,$0004,$0006,$0008,$000c
		.dc	$0010,$0018,$0020,$0030,$0040,$0060,$0080,$00c0
		.dc	$0100,$0180,$0200,$0300,$0400,$0600,$0800,$0c00
		.dc	$1000,$1800,$2000,$3000,$4000,$6000,$0000,$0000

		.dc	$0000,$0000,$0000,$0000,$0001,$0001,$0002,$0002
		.dc	$0003,$0003,$0004,$0004,$0005,$0005,$0006,$0006
		.dc	$0007,$0007,$0008,$0008,$0009,$0009,$000a,$000a
		.dc	$000b,$000b,$000c,$000c,$000d,$000d,$0000,$0000

sort_table:
		.dc.b	$10,$11,$12
		.dc.b	$00,$08,$07,$09
		.dc.b	$06,$0a,$05,$0b
		.dc.b	$04,$0c,$03,$0d
		.dc.b	$02,$0e,$01,$0f

zx_opt:		.dc.b	'zx_opt',0
zip_ext:	.dc.b	'.zip',0

method_table:		;01234567
		.dc.b	'Stored  '
		.dc.b	'Shrunk  '
		.dc.b	'Reduce1 '
		.dc.b	'Reduce2 '
		.dc.b	'Reduce3 '
		.dc.b	'Reduce4 '
		.dc.b	'Implode '
		.dc.b	'Token   '
		.dc.b	'Deflate '
		.dc.b	'EnhDefl '
		.dc.b	'ImplDcl '
		.dc.b	'Unknown '
		.dc.b	' total  '

unknown_format_error_message:
		.dc.b	'̃tH[}bgɂ͑ΉĂ܂',CRLF,0

encrypted_error_message:
		.dc.b	'ÍĂ܂',CRLF,0

file_header_error_message:
		.dc.b	'wb_\ُł',CRLF,0

item_list:	.dc.b	CRLF
		.dc.b	'Method    Size    Length   Ratio    Atr     Date     Time      Name',CRLF
item_list2:	.dc.b	'======= ======== ======== ======= ======= ======== ======== ==========',CRLF,0
item_list3:	.dc.b	' files',CRLF
crlf:		.dc.b	CRLF,0

help_message:
		.dc.b  'X68k ZIP archive extractor version 1.21 patchlevel ',PATCHLEVEL,CRLF
		.dc.b  ' Copyright 1994,95 M.Harashino, ',PATCHDATE,' ',PATCHAUTHOR,'.',CRLF
		.dc.b  'gFzx [<switch>] <zip-file> [<ext-file> cc ]',CRLF
		.dc.b  '	-x[n]		ɂWJ(default)',CRLF
		.dc.b  '	-e[n]		ɂpX𖳎ēWJ',CRLF
		.dc.b  '	-t[n]		ɂ̂bqbeXgs',CRLF
		.dc.b  '	-l -v -1	ɂ̈ꗗ\',CRLF
		.dc.b  '	-a		t@C',CRLF
		.dc.b  '	-b <path>	WJfBNgw肷',CRLF
		.dc.b  '	-c[n]		ƍsȂ',CRLF
		.dc.b  '	-i		啶^ʂ',CRLF
		.dc.b  '	-m		₢킹sȂ',CRLF
		.dc.b  '	-n[n]		ʕ\sȂ',CRLF
		.dc.b  '	-p[n]		Wo͂֏o͂',CRLF
		.dc.b  '	-s		󂫗eʂmF',CRLF
		.dc.b  '	-w		oꊇčs',CRLF
**
**		.dc.b  '	-h		wvbZ[W\',CRLF
		.dc.b	0


* Block Storage Section ----------------------- *

		.bss
		.even

file_handle:	.ds	1

cnv_table:	.ds.l	1

stored_flag:	.ds	1

ext_bottom_address:
		.ds.l	1

zip_cdfh_buf:	.ds.l	1
zip_cdfh_ptr:	.ds.l	1
zip_cdfh_size:	.ds.l	1
preamble_size:	.ds.l	1

percentage_flag:
		.ds	1
percentage_work1:
		.ds.l	1
percentage_work2:
		.ds.l	1

.ifdef __EX__
division_flag:	.ds	1
division_size:	.ds.l	1
src_top_address:.ds.l	1
dictionary_size:.ds.l	1
ext_bottom_address2:
		.ds.l	1
.endif


* Offset Table -------------------------------- *

		.offset	0
branch_table::
		.ds.l	branch_max
table1:
		.ds.b	$120+(1<<el1)*2
		.ds	1
table2:
		.ds.b	32+(1<<el2)*2
		.ds	1
filename_work::
		.ds.b	64+1+22+1
zip_bss_bottom:


bss_bottom:	.equ	zip_bss_bottom


		.end

* End of File --------------------------------- *
